/*

  GOOGLECALC.DLL

  Loadmodule for Litestep shell (and hereby compatible clones)
  Copyright (C) 2001-2002 Pavel Vitis
  pavel.vitis@seznam.cz
  http://blackdaemon.no-ip.org/litestep

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****

TODO:

****/
#include "main.h"
#include <wininet.h>

#define TOKEN_START	"calc_img.gif"
#define TOKEN_LEFT	"<b>"
#define TOKEN_RIGHT	"</b>"
#define TOKEN_END	"</b>"
#define TOKEN_FAILED	"<p class=g>"

BOOL isOrdinaryChar(char c) {
	char ch = tolower(c);
	if(ch == 'a' || ch == 'b' || ch == 'c' || ch == 'd' || ch == 'e'
		|| ch == 'f' || ch == 'g' || ch == 'h' || ch == 'i' || ch == 'j'
		|| ch == 'k' || ch == 'l' || ch == 'm' || ch == 'n' || ch == 'o'
		|| ch == 'p' || ch == 'q' || ch == 'r' || ch == 's' || ch == 't'
		|| ch == 'u' || ch == 'v' || ch == 'w' || ch == 'x' || ch == 'y'
		|| ch == 'z' || ch == '0' || ch == '1' || ch == '2' || ch == '3'
		|| ch == '4' || ch == '5' || ch == '6' || ch == '7' || ch == '8'
		|| ch == '9') {
		return true;
	}
	return false;
}

char *URLEncode(LPCSTR str) {
	int str_len = strlen(str);
	int bufsize = (str_len+1)*sizeof(char);
	char* buff = (char *)malloc(bufsize);
	int bufpos = 0;
	for(int i=0; i < str_len; i++) {
		if (isOrdinaryChar(str[i])) {
			buff[bufpos] = str[i];
			bufpos++;
		} else
		if (str[i] == ' ') {
			buff[bufpos] = '+';
			bufpos++;
		} else {
			char tmp[6];
			sprintf(tmp, "%%%0X", str[i]);
			bufsize = bufsize+strlen(tmp)-1;
			buff = (char *)realloc(buff, bufsize);
			buff[bufpos] = tmp[0];
			bufpos++;
			buff[bufpos] = tmp[1];
			bufpos++;
			buff[bufpos] = tmp[2];
			bufpos++;
		}
	}
	buff[bufpos] = '\0';
	return buff;
}

LPSTR GetHttpData(HINTERNET hRequest)
{
	DWORD dwBytesRead;
	char szBuffer[1024];
	DWORD dwDataSize = 1;

	if (!hRequest) {
		return NULL;
	}

	LPSTR pszData = (LPSTR) malloc(sizeof(char));
	char *startpos = NULL, *endpos = NULL, *failed = NULL;

	do {
		BOOL bRead = InternetReadFile(hRequest,szBuffer,1024,&dwBytesRead);
		if (0 == dwBytesRead || !bRead)
			break;

		pszData = (char *) realloc(pszData,dwDataSize + dwBytesRead);
		memcpy(pszData + dwDataSize -1,szBuffer,dwBytesRead);
		dwDataSize += dwBytesRead;

		if (NULL == startpos) {
			startpos = strstr(pszData, TOKEN_START);
		}
		if (NULL != startpos) {
			endpos = strstr(startpos, TOKEN_END);
			if (NULL != endpos) {
				break;
			}
		}
		else {
			failed = strstr(pszData, TOKEN_FAILED);
			if (NULL != failed) {
				if (verbose) {
					MessageBox( hLitestep, pszData, ST_NAME " Raw HTML result, calculator failure", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
				}

				free(pszData);
				return NULL;
			}
		}
	}
	while(dwBytesRead > 0);

	pszData[dwDataSize-1] = '\0';

	if (verbose) {
		MessageBox( hLitestep, pszData, ST_NAME " Raw HTML result, calculator success", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
	}

	return pszData;
}

void removeHTMLTags(char *szHTML)
{
	if (szHTML == NULL || szHTML[0] == '\0') {
		return;
	}

	char *szPos = szHTML, *szPos2 = NULL;
	int movelen;
	while ((szPos[0] != '\0') && ((szPos = strstr(szPos, "<")) != NULL))
	{
		szPos2 = strstr(szPos, ">");
		if (szPos2 == NULL) {
			szPos2 = szPos;
		}
		else {
			if (strnicmp(szPos, "<sup", szPos2-szPos) == 0) {
				szPos[0] = '^';
				szPos++;
			}
		}
		szPos2++;
		movelen = ((szHTML + strlen(szHTML) + 1) - szPos2) + 1;
		if (movelen > 0) {
			memmove(szPos, szPos2, movelen);
		}
	}

	szPos = szHTML;
	while ((szPos[0] != '\0') && ((szPos = strstr(szPos, "&")) != NULL))
	{
		szPos2 = strstr(szPos, ";");
		if (szPos2 != NULL && szPos2-szPos <= 6) {
			if (strnicmp(szPos, "&amp", szPos2-szPos) == 0) {
				szPos[0] = '&';
				szPos++;
			}
			else
			if (strnicmp(szPos, "&#215", szPos2-szPos) == 0 || strnicmp(szPos, "&times", szPos2-szPos) == 0) {
				szPos[0] = '*';
				szPos++;
			}
			else
			if (strnicmp(szPos, "&#176", szPos2-szPos) == 0 || strnicmp(szPos, "&deg", szPos2-szPos) == 0) {
				szPos[0] = '';
				szPos++;
			}
			else
			if (strnicmp(szPos, "&gt", szPos2-szPos) == 0) {
				szPos[0] = '>';
				szPos++;
			}
			else
			if (strnicmp(szPos, "&lt", szPos2-szPos) == 0) {
				szPos[0] = '<';
				szPos++;
			}
			else
			if (strnicmp(szPos, "&nbsp", szPos2-szPos) == 0) {
				szPos[0] = ' ';
				szPos++;
			}
			// Skip ;
			szPos2++;
			movelen = ((szHTML + strlen(szHTML) + 1) - szPos2) + 1;
			if (movelen > 0) {
				memmove(szPos, szPos2, movelen);
			}
		}
		else {
			szPos++;
		}
	}
}

BOOL queryGoogle(char *buffer, int bufsize, LPCSTR query) {
	BOOL success = FALSE;

	buffer[0] = '\0';

	if (verbose) {
		MessageBox( NULL, query, ST_NAME " query", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
	}

	HINTERNET hInternet;
	hInternet = InternetOpen(
    	"Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0; MSNATLAS01.CZ)",
		(proxy_type == PROXYTYPE_DEFINED ? INTERNET_OPEN_TYPE_PROXY :
			proxy_type = PROXYTYPE_NONE ? INTERNET_OPEN_TYPE_DIRECT :
				INTERNET_OPEN_TYPE_PRECONFIG_WITH_NO_AUTOPROXY),
		(proxy_type == PROXYTYPE_DEFINED ? proxy_host : NULL),
		NULL,
		0);

	HINTERNET hSession;
	hSession = InternetConnect(hInternet, "www.google.com",
                         INTERNET_DEFAULT_HTTP_PORT ,
                         NULL, NULL, INTERNET_SERVICE_HTTP, 0, 0);

	if (hSession != NULL)
	{
		DWORD dwFlags = INTERNET_FLAG_KEEP_CONNECTION | INTERNET_FLAG_DONT_CACHE |
                INTERNET_FLAG_RELOAD | INTERNET_FLAG_NO_COOKIES;
		char *pszData;

		char *encodedQuery = URLEncode(query);
//		MessageBox( NULL, encodedQuery, ST_NAME " encoded query", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );

		char completeQuery[1024];
		completeQuery[0] = '\0';
		sprintf(completeQuery, "/search?q=%s%%3D", encodedQuery);
		free(encodedQuery);

		if (verbose) {
			MessageBox( NULL, completeQuery, ST_NAME " complete query", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
		}

		HINTERNET hRequest = HttpOpenRequest( hSession, "GET",
                                      completeQuery,
                                      NULL, NULL, NULL, dwFlags, 0);


		if (hRequest != NULL)
		{
			HttpSendRequest(hRequest,NULL,0,NULL,0);
			pszData = GetHttpData(hRequest);
			InternetCloseHandle(hRequest);

			buffer[0] = '\0';
			if (NULL != pszData) {
				char *pos = strstr(pszData, TOKEN_START);
				if (pos) {
					pos = strstr(pos, TOKEN_LEFT);
					if (pos) {
						pos += 3;
						char *end = strstr(pos, TOKEN_RIGHT);
						if (pos && end && end > pos) {
							int size = (bufsize > end-pos ? end-pos : bufsize-1);
							memcpy(buffer, pos, size);
							buffer[size] = '\0';

							if (verbose) {
								MessageBox( hLitestep, buffer, ST_NAME " parsed result", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
							}

							removeHTMLTags(buffer);

							if (verbose) {
								MessageBox( hLitestep, buffer, ST_NAME " detokenized result", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
							}
						}
					}
				}

				if (buffer[0] != '\0') {
					success = TRUE;
	//				MessageBox( hLitestep, result, ST_NAME " HTML result", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
				}
				else {
	//				MessageBox( hLitestep, "None", ST_NAME " HTML result", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
				}
				free(pszData);
			}
		}

		InternetCloseHandle(hSession);
	}

	return success;
}
