/*

  This file is part of GESTURES.DLL source code, see MAIN.C for
  detailed information.

  Copyright (C) 2000-2001 Pavel Vitis
  pavel.vitis@seznam.cz
  http://lsg.come.to/


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****************************************************************************
****************************************************************************/

#ifndef __MAIN_H
#define __MAIN_H

#include <windows.h>
#include "wharfdata.h"
#include "lsapi.h"

#define WIN32_LEAN_AND_MEAN

#define true TRUE
#define false FALSE;

#ifndef __cplusplus
	typedef BOOL bool;
#endif

#define STRVALID(s) ((s != NULL) && (strlen(s) > 0))
#define NELEMENTS(a) (sizeof(a)/sizeof(a[0]))

// strings
#define ST_SHORTNAME      TEXT("googleCalc")
#define ST_NAME           TEXT("GOOGLECALC.DLL")
#define ST_VERSION        TEXT("1.1")
#define ST_AUTHOR         TEXT("pavelvitis")
#define ST_REVID          ST_SHORTNAME TEXT(" ") ST_VERSION TEXT(" (") __DATE__ TEXT(" / ") __TIME__ TEXT(") ") ST_AUTHOR

// window classes
#define WC_LSDESKTOP      TEXT("DesktopBackgroundClass")
#define WC_MAIN           TEXT("ls_") ST_SHORTNAME TEXT("_toolwnd")

#define	PROXYTYPE_DEFAULT	0
#define	PROXYTYPE_NONE		1
#define	PROXYTYPE_DEFINED	2

extern HINSTANCE DLLInstance;

extern HWND ToolWindow;
extern HWND hLitestep;
extern HWND hDesktop;
extern char *steprcPath;

extern BOOL module_enabled;
extern char *run_on_result;

extern int proxy_type;
extern char *proxy_host;
extern proxy_port;
extern BOOL verbose;

void addBangs(void);
void removeBangs(void);

BOOL queryGoogle(char *buffer, int bufsize, LPCSTR query);
void initConfig(void);
void doneConfig(void);

#ifdef __cplusplus
extern "C" {
#endif

__declspec( dllexport ) int initModule( HWND, HINSTANCE, wharfDataType* );
__declspec( dllexport ) int initModuleEx( HWND, HINSTANCE, LPCSTR );
__declspec( dllexport ) void quitModule( HINSTANCE );
__declspec( dllexport ) BOOL WINAPI LibMain( HINSTANCE, DWORD, LPVOID );

#ifdef __cplusplus
}
#endif


#endif	//__MAIN_H
